function ret = bspline3(x,y,xx)
k = 4;
% original interpolation points
n = length(x);
x = x(:);
y = y(:);
% knots
t = [x(1)*ones(k,1);x(3:n-2);x(n)*ones(k,1)];
A = zeros(n,n);
for j = 1:n
  A(:,j) = BSplineEval(j,k,t,x);
end
c = A\y;
ret = spmak(t,c'); % the vector of coefficients has to be row
if (nargin == 3)
  ret = spval(ret,xx);
end
%s = zeros(size(xx));
%for j = 1:n
%  s = s+c(j)*BSplineEval(j,k,t,xx);
%end
